tbb::flow::interface11::continue_node< Output, Policy > Class Template Reference

Implements an executable node that supports continue_msg -> Output. More...

`#include <flow_graph.h>`

Inheritance diagram for tbb::flow::interface11::continue_node< Output, Policy >:
Collaboration diagram for tbb::flow::interface11::continue_node< Output, Policy >:

## Public Types

typedef continue_msg | input_type
typedef Output | output_type
typedef internal::continue_input< Output, Policy > | input_impl_type
typedef internal::function_output< output_type > | fOutput_type
typedef input_impl_type::predecessor_type | predecessor_type
typedef fOutput_type::successor_type | successor_type
Public Types inherited from internal::continue_input< Output, Policy >
typedef continue_msg | input_type
| The input type of this receiver. More...
typedef Output | output_type
| The output type of this receiver. More...
typedef function_body< input_type, output_type > | function_body_type
typedef continue_input< output_type, Policy > | class_type
Public Types inherited from internal::function_output< Output >
typedef Output | output_type
typedef sender< output_type >::successor_type | successor_type
typedef broadcast_cache< output_type > | broadcast_cache_type
Public Types inherited from tbb::flow::interface11::internal::untyped_sender
typedef untyped_receiver | successor_type
| The successor type for this node. More...

## Public Member Functions

template<typename Body >
__TBB_NOINLINE_SYM | continue_node (graph &g,)
| Constructor for executable node with continue_msg -> Output. More...
template<typename Body >
__TBB_NOINLINE_SYM | continue_node (graph &g, int number_of_predecessors,)
| Constructor for executable node with continue_msg -> Output. More...
__TBB_NOINLINE_SYM | continue_node (const continue_node &src)
| Copy constructor. More...
Public Member Functions inherited from tbb::flow::interface11::graph_node
| graph_node (graph &g)
virtual | ~graph_node ()
Public Member Functions inherited from internal::continue_input< Output, Policy >
template<typename Body >
| continue_input (graph &g, __TBB_FLOW_GRAPH_PRIORITY_ARG1(Body &body, node_priority_t priority))
template<typename Body >
| continue_input (graph &g, int number_of_predecessors,)
| continue_input (const continue_input &src)
| ~continue_input ()
template<typename Body >
Body | copy_function_object ()
void | reset_receiver (reset_flags f) __TBB_override
Public Member Functions inherited from internal::function_output< Output >
| function_output (graph &g)
| function_output (const function_output &other)
bool | register_successor (successor_type &r) __TBB_override
| Adds a new successor to this node. More...
bool | remove_successor (successor_type &r) __TBB_override
| Removes a successor from this node. More...
task * | try_put_task (const output_type &i)
broadcast_cache_type & | successors ()
graph & | graph_reference () const
Public Member Functions inherited from tbb::flow::interface11::sender< Output >
virtual bool | try_get (Output &)
| Request an item from the sender. More...
virtual bool | try_reserve (Output &)
| Reserves an item in the sender. More...
Public Member Functions inherited from tbb::flow::interface11::internal::untyped_sender
virtual | ~untyped_sender ()
virtual bool | try_release ()
| Releases the reserved item. More...
virtual bool | try_consume ()
| Consumes the reserved item. More...

## Protected Member Functions

internal::broadcast_cache< output_type > & | successors () __TBB_override
void | reset_node (reset_flags f) __TBB_override
Protected Member Functions inherited from internal::continue_input< Output, Policy >
task * | apply_body_bypass (input_type)
| Applies the body to the provided input. More...
task * | execute () __TBB_override
graph & | graph_reference () const __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::sender< Output >
virtual bool | try_get_wrapper (void *p, bool is_async) __TBB_override
virtual bool | try_reserve_wrapper (void *p, bool is_async) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::internal::untyped_sender
template<typename X >
bool | try_get (X &t)
| Request an item from the sender. More...
template<typename X >
bool | try_reserve (X &t)
| Reserves an item in the sender. More...

## Friends

template<typename R , typename B >
class | run_and_put_task
template<typename X , typename Y >
class | internal::broadcast_cache
template<typename X , typename Y >
class | internal::round_robin_cache

## Additional Inherited Members

Public Attributes inherited from tbb::flow::interface11::sender< Output >
__TBB_DEPRECATED typedef Output | output_type
| The output type of this sender. More...
__TBB_DEPRECATED typedef internal::async_helpers< Output >::filtered_type | filtered_type
Protected Attributes inherited from tbb::flow::interface11::graph_node
graph & | my_graph
graph_node * | next
graph_node * | prev
Protected Attributes inherited from internal::continue_input< Output, Policy >
graph & | my_graph_ref
function_body_type * | my_body
function_body_type * | my_init_body
Protected Attributes inherited from internal::function_output< Output >
broadcast_cache_type | my_successors
graph & | my_graph_ref

## Detailed Description

### template<typename Output, typename Policy = internal::Policy<void>>
class tbb::flow::interface11::continue_node< Output, Policy >

Implements an executable node that supports continue_msg -> Output.

Definition at line 1441 of file flow_graph.h.

## Member Typedef Documentation

## fOutput_type

template<typename Output , typename Policy = internal::Policy<void>>

typedef internal::function_output<output_type> tbb::flow::interface11::continue_node< Output, Policy >::fOutput_type

Definition at line 1447 of file flow_graph.h.

## input_impl_type

template<typename Output , typename Policy = internal::Policy<void>>

typedef internal::continue_input<Output, Policy> tbb::flow::interface11::continue_node< Output, Policy >::input_impl_type

Definition at line 1446 of file flow_graph.h.

## input_type

template<typename Output , typename Policy = internal::Policy<void>>

typedef continue_msg tbb::flow::interface11::continue_node< Output, Policy >::input_type

Definition at line 1444 of file flow_graph.h.

## output_type

template<typename Output , typename Policy = internal::Policy<void>>

typedef Output tbb::flow::interface11::continue_node< Output, Policy >::output_type

Definition at line 1445 of file flow_graph.h.

## predecessor_type

template<typename Output , typename Policy = internal::Policy<void>>

typedef input_impl_type::predecessor_type tbb::flow::interface11::continue_node< Output, Policy >::predecessor_type

Definition at line 1448 of file flow_graph.h.

## successor_type

template<typename Output , typename Policy = internal::Policy<void>>

typedef fOutput_type::successor_type tbb::flow::interface11::continue_node< Output, Policy >::successor_type

Definition at line 1449 of file flow_graph.h.

## Constructor & Destructor Documentation

## continue_node() [1/3]

template<typename Output , typename Policy = internal::Policy<void>>
template<typename Body >

__TBB_NOINLINE_SYM tbb::flow::interface11::continue_node< Output, Policy >::continue_node | ( | graph & | g | ) |

inline

Constructor for executable node with continue_msg -> Output.

Definition at line 1453 of file flow_graph.h.

: graph_node(g), input_impl_type( g, __TBB_FLOW_GRAPH_PRIORITY_ARG1(body, priority) ),
fOutput_type(g) {
tbb::internal::fgt_node_with_body( CODEPTR(), tbb::internal::FLOW_CONTINUE_NODE, &this->my_graph,
static_cast<receiver<input_type> *>(this),
static_cast<sender<output_type> *>(this), this->my_body );
}

References CODEPTR, tbb::internal::fgt_node_with_body(), internal::continue_input< Output, Policy >::my_body, and tbb::flow::interface11::graph_node::my_graph.

Here is the call graph for this function:

## continue_node() [2/3]

template<typename Output , typename Policy = internal::Policy<void>>
template<typename Body >

__TBB_NOINLINE_SYM tbb::flow::interface11::continue_node< Output, Policy >::continue_node | ( | graph & | g,
|  | int | number_of_predecessors
| ) |  |

inline

Constructor for executable node with continue_msg -> Output.

Definition at line 1490 of file flow_graph.h.

: graph_node(g)
, input_impl_type(g, number_of_predecessors, __TBB_FLOW_GRAPH_PRIORITY_ARG1(body, priority)),
fOutput_type(g) {
tbb::internal::fgt_node_with_body( CODEPTR(), tbb::internal::FLOW_CONTINUE_NODE, &this->my_graph,
static_cast<receiver<input_type> *>(this),
static_cast<sender<output_type> *>(this), this->my_body );
}

References CODEPTR, tbb::internal::fgt_node_with_body(), internal::continue_input< Output, Policy >::my_body, and tbb::flow::interface11::graph_node::my_graph.

Here is the call graph for this function:

## continue_node() [3/3]

template<typename Output , typename Policy = internal::Policy<void>>

__TBB_NOINLINE_SYM tbb::flow::interface11::continue_node< Output, Policy >::continue_node | ( | const continue_node< Output, Policy > & | src | ) |

inline

Copy constructor.

Definition at line 1528 of file flow_graph.h.

:
graph_node(src.my_graph), input_impl_type(src),
internal::function_output<Output>(src.my_graph) {
tbb::internal::fgt_node_with_body( CODEPTR(), tbb::internal::FLOW_CONTINUE_NODE, &this->my_graph,
static_cast<receiver<input_type> *>(this),
static_cast<sender<output_type> *>(this), this->my_body );
}

References CODEPTR, tbb::internal::fgt_node_with_body(), internal::continue_input< Output, Policy >::my_body, and tbb::flow::interface11::graph_node::my_graph.

Here is the call graph for this function:

## Member Function Documentation

## reset_node()

template<typename Output , typename Policy = internal::Policy<void>>

void tbb::flow::interface11::continue_node< Output, Policy >::reset_node | ( | reset_flags | f | ) |

inline protected virtual

Implements tbb::flow::interface11::graph_node.

Definition at line 1556 of file flow_graph.h.

{
input_impl_type::reset_receiver(f);
if(f & rf_clear_edges)successors().clear();
__TBB_ASSERT(!(f & rf_clear_edges) || successors().empty(), "continue_node not reset");
}

References __TBB_ASSERT, internal::successor_cache< T, M >::empty(), internal::continue_input< Output, Policy >::reset_receiver(), tbb::flow::interface11::rf_clear_edges, and tbb::flow::interface11::continue_node< Output, Policy >::successors().

Here is the call graph for this function:

## successors()

template<typename Output , typename Policy = internal::Policy<void>>

internal::broadcast_cache<output_type>& tbb::flow::interface11::continue_node< Output, Policy >::successors | ( |  | ) |

inline protected virtual

Implements internal::continue_input< Output, Policy >.

Definition at line 1554 of file flow_graph.h.

{ return fOutput_type::my_successors; }

References internal::function_output< Output >::my_successors.

Referenced by tbb::flow::interface11::continue_node< Output, Policy >::reset_node().

Here is the caller graph for this function:

## Friends And Related Function Documentation

## internal::broadcast_cache

template<typename Output , typename Policy = internal::Policy<void>>
template<typename X , typename Y >

friend class internal::broadcast_cache

friend

Definition at line 1551 of file flow_graph.h.

## internal::round_robin_cache

template<typename Output , typename Policy = internal::Policy<void>>
template<typename X , typename Y >

friend class internal::round_robin_cache

friend

Definition at line 1552 of file flow_graph.h.

## run_and_put_task

template<typename Output , typename Policy = internal::Policy<void>>
template<typename R , typename B >

friend class run_and_put_task

friend

Definition at line 1550 of file flow_graph.h.

The documentation for this class was generated from the following file:

- flow_graph.h

CODEPTR
#define CODEPTR()
Definition: _flow_graph_trace_impl.h:297
tbb::flow::interface11::graph_node::graph_node
graph_node(graph &g)
Definition: flow_graph.h:880
__TBB_ASSERT
#define __TBB_ASSERT(predicate, comment)
No-op version of __TBB_ASSERT.
Definition: tbb_stddef.h:165
tbb::internal::fgt_node_with_body
static void fgt_node_with_body(void *, string_index, void *, void *, void *)
Definition: _flow_graph_trace_impl.h:330
__TBB_FLOW_GRAPH_PRIORITY_ARG1
#define __TBB_FLOW_GRAPH_PRIORITY_ARG1(arg1, priority)
Definition: _flow_graph_impl.h:40
internal::function_output
Implements methods for both executable and function nodes that puts Output to its successors.
Definition: _flow_graph_node_impl.h:854
tbb::flow::interface11::graph_node::my_graph
graph & my_graph
Definition: _flow_graph_impl.h:464
internal::continue_input::reset_receiver
void reset_receiver(reset_flags f) __TBB_override
Definition: _flow_graph_node_impl.h:797
tbb::flow::interface11::continue_node::successors
internal::broadcast_cache< output_type > & successors() __TBB_override
Definition: flow_graph.h:1554
internal::continue_input::my_body
function_body_type * my_body
Definition: _flow_graph_node_impl.h:809
tbb::flow::interface11::continue_node::input_impl_type
internal::continue_input< Output, Policy > input_impl_type
Definition: flow_graph.h:1446
internal::function_output::my_successors
broadcast_cache_type my_successors
Definition: _flow_graph_node_impl.h:920
tbb::flow::interface11::rf_clear_edges
Definition: _flow_graph_impl.h:161
tbb::flow::interface11::continue_node::fOutput_type
internal::function_output< output_type > fOutput_type
Definition: flow_graph.h:1447

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.